{-  
 *  Programmer:	Piotr Borek
 *  E-mail:     piotrborek@op.pl
 *  Copyright 2014 Piotr Borek
 *
 *  Distributed under the terms of the GPL (GNU Public License)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-}

module Main where

import Text.I18N.GetText
import System.Locale.SetLocale
import System.Directory
import System.Environment
import System.FilePath.Posix

import Mp.Configuration.Configuration
import Mp.Player.Daemon
import Mp.UI.Main
import Mp.Utils.Utils

main :: IO ()
main = do
    args <- getArgs
    exePath <- findExecutable "mp"
    dir <- getCurrentDirectory

    _ <- setLocale LC_ALL (Just "")

    _ <- case exePath of
             Just path -> do
                let (exeDir, _) = separateFilePath path
                bindTextDomain "mp" (Just $ exeDir </> "i18n")
             Nothing   ->
                bindTextDomain "mp" (Just $ dir </> "i18n")

    _ <- textDomain (Just "mp")

    makeDefaultConfiguration
    runPlayerDaemon

    if any ("--daemon" == ) args then
        return ()
    else
        makeAndRunUI
