{-  
 *  Programmer:	Piotr Borek
 *  E-mail:     piotrborek@op.pl
 *  Copyright 2014 Piotr Borek
 *
 *  Distributed under the terms of the GPL (GNU Public License)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-}

module Mp.Player.Daemon (
    runPlayerDaemon
) where

import System.Directory
import System.Posix.Daemon
import System.FilePath.Posix

import Mp.Configuration.Configuration
import Mp.Player.Server
import Mp.Utils.Exception

runPlayerDaemon :: IO ()
runPlayerDaemon = do
    confDir <- configDirFilePath
    let pidFile    = confDir </> "pid"
    let output_log = confDir </> "daemon_log"
    let socName = confDir </> "mp.socket"

    alreadyRunning <- isRunning pidFile
    if alreadyRunning
        then return ()
        else do
            _ <- try' $ removeFile socName
            runDetached (Just pidFile) (ToFile output_log) (startServerBlocking socName)
