{-  
 *  Programmer:	Piotr Borek
 *  E-mail:     piotrborek@op.pl
 *  Copyright 2014 Piotr Borek
 *
 *  Distributed under the terms of the GPL (GNU Public License)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-}

{-# LANGUAGE OverloadedStrings #-}

module Mp.UI.EditBar (
    EditBar (..),
    EditBarWidget,
    makeUIEditBar
) where

import qualified Data.Text as T
import Control.Applicative

import Graphics.Vty.Widgets.All
import Graphics.Vty hiding (Button)

import Data.ConfigFile

import Mp.Utils.Colors

type EditBarWidget = Widget Edit

data EditBar = EditBar {
    editBarWidget       :: EditBarWidget,
    editBarGetText      :: IO String,
    editBarReset        :: IO (),
    editBarOnKeyPressed :: (Widget Edit -> Key -> [Modifier] -> IO Bool) -> IO ()
}

makeUIEditBar :: ConfigParser -> IO EditBar
makeUIEditBar conf = do
    edit <- editWidget
            >>= withEditAttribute conf

    return EditBar {
        editBarWidget       = edit,
        editBarGetText      = T.unpack <$> getEditText edit,
        editBarReset        = setEditText edit "",
        editBarOnKeyPressed = onKeyPressed edit
    }
